#include <iostream>
#include "cmath"
#include "vector"

using namespace std;
typedef long long ll;


ll f(ll z, vector<vector<ll>> &arr) {
    ll sum = 0;
    for (auto & i : arr) {
        if (z <= i[0])
            sum += i[1] * z;
        else
            sum += i[1] * i[0] + i[2] * (z - i[0]);
    }
    return sum;
}



int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    ll n, z, a, b, p, x = 0;
    ll min_z = -1;
    ll sum_p = 0;
    cin >> n >> p;
    vector<vector<ll>> arr(n);
    for (int t = 0; t < n; t++) {
        cin >> z >> a >> b;
//        x = p / a;
//        if (p % a != 0) {
//            x++;
//        }
//        if (x > z) {
//            x = (p + b * z - a * z) / b;
//            if ((p + b * z - a * z) % b != 0) {
//                x++;
//            }
//        }
        arr[t].push_back(z);
        arr[t].push_back(a);
        arr[t].push_back(b);
        if (z < min_z || min_z == -1)
            min_z = z;

//        sum_p = 0;
//        for (int i = 0; i < t + 1; i++) {
//            if (x > arr[i][0])
//                sum_p += arr[i][1] * arr[i][0] + arr[i][2] * (x - arr[i][0]);
//            else
//                sum_p += arr[i][1] * x;
//        }
//        if (sum_p >= p && (x < min_x || min_x == -1))
//            min_x = x;
    }
    ll l = 1;
    ll r = min_z + 1;
    while (r - l > 1) {
        ll pivot = (r + l) / 2;
        ll ans = f(pivot, arr);
        if (ans > p) {
            r = pivot;
        }
        else {
            l = pivot;
        }
    }
    if (f(l, arr) >= p)
        cout << l;
    else {
        while (true) {
            min_z++;
            ll ans = f(min_z, arr);
            if (ans >= p) {
                cout << min_z;
                break;
            }
        }
    }

//    z = arr[0][0];
//    sum_p = p + 1;
//    while (sum_p > p && z >= 1) {
//        sum_p = 0;
//        for (int i = 0; i < n; i++) {
//            sum_p += arr[i][1] * z;
//        }
//        z--;
//    }
//    if (z + 1 != arr[0][0])
//        cout << z + 1;
//    else {
//        z = arr[0][0] + 1;
//        sum_p = 0;
//        while (sum_p < p) {
//            sum_p = 0;
//            for (int i = 0; i < n; i++) {
//                sum_p += arr[i][1] * z + arr[i][2] * (z - arr[i][0]);
//            }
//            z++;
//        }
//        cout << z - 1;
//    }
}
